=== debian/changelog ===
eccodes (2.0.2-5) unstable; urgency=medium

  * Change deps on libeccodes-tools: put mksh,pdksh ahead of RC-buggy ksh

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 Dec 2016 16:03:15 +0000

eccodes (2.0.2-4) unstable; urgency=medium

  * Add versioned Breaks on libemos-bin. Closes: #847146.
  * Ack. previously fixed bug: Closes: #846561

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Dec 2016 10:14:27 +0000

eccodes (2.0.2-3) unstable; urgency=medium

  * Add Breaks/Replaces python3-eccodes / python3-gribapi. Closes: #847146
  * Minor fixes to gribapi.py for python3

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 06 Dec 2016 10:45:03 +0000

eccodes (2.0.2-2) unstable; urgency=medium

  * eccodes-targets-release.cmake: change /usr/lib to M-A directory in ./rules
    needed by emoslib, magics++, etc.
  * Mark libeccodes0 as M-A: same

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Nov 2016 15:19:47 +0000

eccodes (2.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 28 Nov 2016 15:09:45 +0000

eccodes (2.0.0-2) unstable; urgency=medium

  * Split dh_fixperms for dpkg-buildpackage -A . Closes: #844167
  * Mark --no-parallel. Parallel builds currently unsafe. 
    Closes: #844172, #844174
  * Split data from libeccodes0 library to separate package. Closes: #844065
  * Move souce package from "libdevel" section to "science"
  * Set libeccodes-doc as multi-arch: foreign

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Nov 2016 08:48:02 +0000

eccodes (2.0.0-1) unstable; urgency=medium

  * New upstream release
    - Openjpeg2 patch now merged upstream
    - add remove-rpms.patch to remove refs to missing files
  * Additional copyright notices, thanks to Thorsten Alteholz
  * Now link to libjquery-js for jquery.js docs

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 28 Oct 2016 06:53:26 +0100

eccodes (0.16.0-1) unstable; urgency=medium

  * Initial release. (Closes: #815890)

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 29 Jul 2016 05:06:19 +0100
