=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
#export DEB_LDFLAGS_MAINT_PREPEND := -Wl,-z,defs -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
BUILDDIR=$(CURDIR)/debian/build
UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

# For hardening
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) #  -fPIC
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export LDFLAGS CFLAGS CPPFLAGS CXXFLAGS

PY3VERSM:=$(shell py3versions -d)m

# Don't test on mips. will time out most of the time on low-powered archs
DO_TEST:=true
ARCH:=$(shell dpkg --print-architecture)
ifeq ($(ARCH), mips)
DO_TEST:=false
endif
ifeq ($(ARCH),hppa)
DO_TEST:=false
endif

DO_TEST:=false

BUILD_FLAGS =  \
	-DCMAKE_BUILD_TYPE=Release \
	-DDISABLE_OS_CHECK=ON \
	-DENABLE_PNG=ON \
	-DENABLE_AEC=ON \
	-DENABLE_RPATHS=OFF \
	-DENABLE_RELATIVE_RPATHS=OFF \
	-DHAVE_BIT_REPRODUCIBLE=ON \
	-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}" \
	-DENABLE_ALIGN_MEMORY=ON \
	-DENABLE_GRIB_TIMER=ON \
	-DENABLE_ECCODES_OMP_THREADS=ON \
	-DENABLE_PYTHON=ON \
	-DPYTHON_EXECUTABLE=/usr/bin/python3 

%:
	dh $@ --buildsystem=cmake --with=python3 --builddirectory=${BUILDDIR} --no-parallel

override_dh_auto_configure:
	# Disable python modules until we figure out how to build them properly
	F77=gfortran dh_auto_configure -- \
	    ${BUILD_FLAGS}
	( cd ${BUILDDIR}/data ; tar axpf $(CURDIR)/../eccodes_$(UPSTREAM_VERSION).orig-data.tar.xz )
	( cd python ; swig -python -module gribapi_swig -o swig_wrap_numpy.c gribapi_swig.i )

override_dh_install:
	# Move to multiarch dir
	mkdir -p debian/tmp/${LIBDIR}
	cp -a debian/tmp/usr/lib/lib* debian/tmp/${LIBDIR}
	cp -a debian/tmp/usr/lib/pkgconfig debian/tmp/${LIBDIR}
	for d in libeccodes_f90.so	libeccodes.so ; do \
                cp debian/tmp/$(LIBDIR)/$$d.0 debian/tmp/$(LIBDIR)/$$d.0.0.0 ; \
                chrpath -d debian/tmp/$(LIBDIR)/$$d.0.0.0 ; done
	dh_link -p libeccodes0 $(LIBDIR)/libeccodes.so.0.0.0  $(LIBDIR)/libeccodes.so.0
	dh_link -p libeccodes0 $(LIBDIR)/libeccodes_f90.so.0.0.0  $(LIBDIR)/libeccodes_f90.so.0
	dh_link -p libeccodes-dev $(LIBDIR)/libeccodes.so.0.0.0 $(LIBDIR)/libeccodes.so
	dh_link -p libeccodes-dev $(LIBDIR)/libeccodes_f90.so.0.0.0 $(LIBDIR)/libeccodes_f90.so
	(cd debian/build/python && python3 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	chrpath -d ./debian/tmp/usr/lib/python*/site-packages/gribapi/*.so
	for d in debian/tmp/usr/bin/* ; do \
                ( chrpath -d $$d || echo "Ignoring chrpath error for non-ELF $d" ); \
                done
	dh_numpy3
	dh_install
	#
	# Setup cmake files for magics++, metview, etc.
	#
	mkdir -p debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes
	cp debian/tmp/usr/share/eccodes/cmake/* debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes
	sed -e 's%$${_IMPORT_PREFIX}%/usr%' \
	       < debian/tmp/usr/share/eccodes/cmake/eccodes-targets-release.cmake | \
	sed -e 's%-l${PY3VERSM} %%g' | \
	sed -e 's%/usr/lib/libeccodes%${LIBDIR}/libeccodes%' | \
	sed -e 's%${LIBDIR}/libopenjpeg.so;%%' | sed -e 's%;${LIBDIR}/libpng.so%%g' \
	      > debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes/eccodes-targets-release.cmake
	sed -e 's%;${LIBDIR}/libopenjpeg.so%%g' \
	        < debian/tmp/usr/share/eccodes/cmake/eccodes-config.cmake | \
	sed -e 's%-l${PY3VERSM} %%g' | \
	sed -s 's%/usr/include/${PY3VERSM};%%g' | sed -e 's%/usr/include/python2.7;%%g' | \
	sed -e 's%;${LIBDIR}/libpng.so%%g' \
	        > debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes/grib_api-config.cmake


override_dh_auto_clean:
	dh_auto_clean
	# Things that upstream leaves behind
	find . -name '*.pyc' -delete
	rm -f tests/bitmap.rules tests/out.grib1 tests/out.grib2 tests/out.gribidx \
	      tests/rules tests/simple_ieee_test.grib1.txt tests/statistics.filter \
	      tests/statistics.out tests/x.grib \
	      data/change_scanning_rotated_ll.filter examples/F90/index.idx

override_dh_fixperms_arch:
	dh_fixperms
	test -e /usr/bin/dh_buildinfo && dh_buildinfo
	chmod -x debian/libeccodes-dev/usr/share/doc/libeccodes-dev/examples/F90/include.sh
	chmod +x debian/libeccodes0/usr/share/eccodes/definitions/installDefinitions.sh

override_dh_fixperms_indep:
	# replace jquery with symlink. Run after dh_installdocs
	rm debian/libeccodes-doc/usr/share/doc/libeccodes-doc/html/jquery.js
	ln -s ../../../../javascript/jquery/jquery.js debian/libeccodes-doc/usr/share/doc/libeccodes-doc/html/jquery.js

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true
